# eth-json-rpc-types

> typescript types for JSON-RPC 2.0

## Overview

### Classes

- [EthereumJSONRPC](classes/ethereumjsonrpc.md)

### Interfaces

- [Block](interfaces/block.md)
- [Filter](interfaces/filter.md)
- [Log](interfaces/log.md)
- [Options](interfaces/options.md)
- [ProofAccount](interfaces/proofaccount.md)
- [Receipt](interfaces/receipt.md)
- [StorageProof](interfaces/storageproof.md)
- [SyncingData](interfaces/syncingdata.md)
- [Transaction](interfaces/transaction.md)

### Type aliases

- [Address](README.md#address)
- [AddressOrNull](README.md#addressornull)
- [Addresses](README.md#addresses)
- [BlockDifficulty](README.md#blockdifficulty)
- [BlockExtraData](README.md#blockextradata)
- [BlockGasLimit](README.md#blockgaslimit)
- [BlockGasUsed](README.md#blockgasused)
- [BlockHash](README.md#blockhash)
- [BlockHashOrNull](README.md#blockhashornull)
- [BlockLogsBloom](README.md#blocklogsbloom)
- [BlockNumber](README.md#blocknumber)
- [BlockNumberOrNull](README.md#blocknumberornull)
- [BlockNumberOrTag](README.md#blocknumberortag)
- [BlockNumberTag](README.md#blocknumbertag)
- [BlockOrNull](README.md#blockornull)
- [BlockReceiptsRoot](README.md#blockreceiptsroot)
- [BlockShaUncles](README.md#blockshauncles)
- [BlockSize](README.md#blocksize)
- [BlockStateRoot](README.md#blockstateroot)
- [BlockTimeStamp](README.md#blocktimestamp)
- [BlockTotalDifficulty](README.md#blocktotaldifficulty)
- [BlockTransactionsRoot](README.md#blocktransactionsroot)
- [BloomFilter](README.md#bloomfilter)
- [BooleanVyG3AETh](README.md#booleanvyg3aeth)
- [Bytes](README.md#bytes)
- [ChainId](README.md#chainid)
- [ClientVersion](README.md#clientversion)
- [Data](README.md#data)
- [DataWord](README.md#dataword)
- [Difficulty](README.md#difficulty)
- [EthBlockNumber](README.md#ethblocknumber)
- [EthCall](README.md#ethcall)
- [EthChainId](README.md#ethchainid)
- [EthCoinbase](README.md#ethcoinbase)
- [EthEstimateGas](README.md#ethestimategas)
- [EthGasPrice](README.md#ethgasprice)
- [EthGetBalance](README.md#ethgetbalance)
- [EthGetBlockByHash](README.md#ethgetblockbyhash)
- [EthGetBlockByNumber](README.md#ethgetblockbynumber)
- [EthGetBlockTransactionCountByHash](README.md#ethgetblocktransactioncountbyhash)
- [EthGetBlockTransactionCountByNumber](README.md#ethgetblocktransactioncountbynumber)
- [EthGetCode](README.md#ethgetcode)
- [EthGetFilterChanges](README.md#ethgetfilterchanges)
- [EthGetFilterLogs](README.md#ethgetfilterlogs)
- [EthGetLogs](README.md#ethgetlogs)
- [EthGetProof](README.md#ethgetproof)
- [EthGetRawTransactionByBlockHashAndIndex](README.md#ethgetrawtransactionbyblockhashandindex)
- [EthGetRawTransactionByBlockNumberAndIndex](README.md#ethgetrawtransactionbyblocknumberandindex)
- [EthGetRawTransactionByHash](README.md#ethgetrawtransactionbyhash)
- [EthGetStorageAt](README.md#ethgetstorageat)
- [EthGetTransactionByBlockHashAndIndex](README.md#ethgettransactionbyblockhashandindex)
- [EthGetTransactionByBlockNumberAndIndex](README.md#ethgettransactionbyblocknumberandindex)
- [EthGetTransactionByHash](README.md#ethgettransactionbyhash)
- [EthGetTransactionCount](README.md#ethgettransactioncount)
- [EthGetTransactionReceipt](README.md#ethgettransactionreceipt)
- [EthGetUncleByBlockHashAndIndex](README.md#ethgetunclebyblockhashandindex)
- [EthGetUncleByBlockNumberAndIndex](README.md#ethgetunclebyblocknumberandindex)
- [EthGetUncleCountByBlockHash](README.md#ethgetunclecountbyblockhash)
- [EthGetUncleCountByBlockNumber](README.md#ethgetunclecountbyblocknumber)
- [EthGetWork](README.md#ethgetwork)
- [EthHashrate](README.md#ethhashrate)
- [EthMining](README.md#ethmining)
- [EthNewBlockFilter](README.md#ethnewblockfilter)
- [EthNewFilter](README.md#ethnewfilter)
- [EthNewPendingTransactionFilter](README.md#ethnewpendingtransactionfilter)
- [EthPendingTransactions](README.md#ethpendingtransactions)
- [EthProtocolVersion](README.md#ethprotocolversion)
- [EthSendRawTransaction](README.md#ethsendrawtransaction)
- [EthSubmitHashrate](README.md#ethsubmithashrate)
- [EthSubmitWork](README.md#ethsubmitwork)
- [EthSyncing](README.md#ethsyncing)
- [EthUninstallFilter](README.md#ethuninstallfilter)
- [FilterId](README.md#filterid)
- [From](README.md#from)
- [GasPriceResult](README.md#gaspriceresult)
- [GetWorkResults](README.md#getworkresults)
- [Integer](README.md#integer)
- [IntegerOrNull](README.md#integerornull)
- [IsNetListening](README.md#isnetlistening)
- [IsSyncingResult](README.md#issyncingresult)
- [IsTransactionsIncluded](README.md#istransactionsincluded)
- [Keccak](README.md#keccak)
- [LogAddress](README.md#logaddress)
- [LogData](README.md#logdata)
- [LogIndex](README.md#logindex)
- [LogIsRemoved](README.md#logisremoved)
- [LogResult](README.md#logresult)
- [LogTopics](README.md#logtopics)
- [Logs](README.md#logs)
- [MixHash](README.md#mixhash)
- [NetListening](README.md#netlistening)
- [NetPeerCount](README.md#netpeercount)
- [NetVersion](README.md#netversion)
- [NetworkId](README.md#networkid)
- [Nonce](README.md#nonce)
- [NonceOrNull](README.md#nonceornull)
- [Null](README.md#null)
- [NumConnectedPeers](README.md#numconnectedpeers)
- [OneOrArrayOfAddresses](README.md#oneorarrayofaddresses)
- [Position](README.md#position)
- [PowHash](README.md#powhash)
- [ProofAccountAddress](README.md#proofaccountaddress)
- [ProofAccountBalance](README.md#proofaccountbalance)
- [ProofAccountCodeHash](README.md#proofaccountcodehash)
- [ProofAccountNonce](README.md#proofaccountnonce)
- [ProofAccountOrNull](README.md#proofaccountornull)
- [ProofAccountStorageHash](README.md#proofaccountstoragehash)
- [ProofNode](README.md#proofnode)
- [ProofNodes](README.md#proofnodes)
- [ReceiptContractAddress](README.md#receiptcontractaddress)
- [ReceiptCumulativeGasUsed](README.md#receiptcumulativegasused)
- [ReceiptGasUsed](README.md#receiptgasused)
- [ReceiptPostTransactionState](README.md#receiptposttransactionstate)
- [ReceiptStatus](README.md#receiptstatus)
- [SeedHash](README.md#seedhash)
- [SetOfLogs](README.md#setoflogs)
- [StorageKeys](README.md#storagekeys)
- [StorageProofKey](README.md#storageproofkey)
- [StorageProofSet](README.md#storageproofset)
- [StorageProofValue](README.md#storageproofvalue)
- [SyncingDataCurrentBlock](README.md#syncingdatacurrentblock)
- [SyncingDataHighestBlock](README.md#syncingdatahighestblock)
- [SyncingDataKnownStates](README.md#syncingdataknownstates)
- [SyncingDataPulledStates](README.md#syncingdatapulledstates)
- [SyncingDataStartingBlock](README.md#syncingdatastartingblock)
- [To](README.md#to)
- [Topic](README.md#topic)
- [TransactionGas](README.md#transactiongas)
- [TransactionGasPrice](README.md#transactiongasprice)
- [TransactionHash](README.md#transactionhash)
- [TransactionIndex](README.md#transactionindex)
- [TransactionInput](README.md#transactioninput)
- [TransactionNonce](README.md#transactionnonce)
- [TransactionOrNull](README.md#transactionornull)
- [TransactionOrTransactionHash](README.md#transactionortransactionhash)
- [TransactionReceiptOrNull](README.md#transactionreceiptornull)
- [TransactionSigR](README.md#transactionsigr)
- [TransactionSigS](README.md#transactionsigs)
- [TransactionSigV](README.md#transactionsigv)
- [TransactionValue](README.md#transactionvalue)
- [Transactions](README.md#transactions)
- [TransactionsOrHashes](README.md#transactionsorhashes)
- [UncleHash](README.md#unclehash)
- [UncleHashes](README.md#unclehashes)
- [Web3ClientVersion](README.md#web3clientversion)
- [Web3Sha3](README.md#web3sha3)

## Type aliases

### Address

Ƭ **Address**: _string_

Defined in index.d.ts:69

---

### AddressOrNull

Ƭ **AddressOrNull**: _[Address](README.md#address) | [Null](README.md#null)_

Defined in index.d.ts:186

---

### Addresses

Ƭ **Addresses**: _[Address](README.md#address)[]_

Defined in index.d.ts:123

List of contract addresses from which to monitor events

---

### BlockDifficulty

Ƭ **BlockDifficulty**: _string_

Defined in index.d.ts:192

Integer of the difficulty for this block

---

### BlockExtraData

Ƭ **BlockExtraData**: _string_

Defined in index.d.ts:204

The 'extra data' field of this block

---

### BlockGasLimit

Ƭ **BlockGasLimit**: _string_

Defined in index.d.ts:216

The maximum gas allowed in this block

---

### BlockGasUsed

Ƭ **BlockGasUsed**: _string_

Defined in index.d.ts:222

The total used gas by all transactions in this block

---

### BlockHash

Ƭ **BlockHash**: _string_

Defined in index.d.ts:148

The hex representation of the Keccak 256 of the RLP encoded block

---

### BlockHashOrNull

Ƭ **BlockHashOrNull**: _[Keccak](README.md#keccak) | [Null](README.md#null)_

Defined in index.d.ts:20

The block hash or null when its the pending block

---

### BlockLogsBloom

Ƭ **BlockLogsBloom**: _string_

Defined in index.d.ts:167

The bloom filter for the logs of the block or null when its the pending block

---

### BlockNumber

Ƭ **BlockNumber**: _string_

Defined in index.d.ts:26

The hex representation of the block's height

---

### BlockNumberOrNull

Ƭ **BlockNumberOrNull**: _[BlockNumber](README.md#blocknumber) | [Null](README.md#null)_

Defined in index.d.ts:32

The block number or null when its the pending block

---

### BlockNumberOrTag

Ƭ **BlockNumberOrTag**: _[BlockNumber](README.md#blocknumber) | [BlockNumberTag](README.md#blocknumbertag)_

Defined in index.d.ts:539

---

### BlockNumberTag

Ƭ **BlockNumberTag**: _"earliest" | "latest" | "pending"_

Defined in index.d.ts:117

The optional block height description

---

### BlockOrNull

Ƭ **BlockOrNull**: _[Block](interfaces/block.md) | [Null](README.md#null)_

Defined in index.d.ts:606

---

### BlockReceiptsRoot

Ƭ **BlockReceiptsRoot**: _string_

Defined in index.d.ts:185

The root of the receipts trie of the block

---

### BlockShaUncles

Ƭ **BlockShaUncles**: _string_

Defined in index.d.ts:161

Keccak hash of the uncles data in the block

---

### BlockSize

Ƭ **BlockSize**: _string_

Defined in index.d.ts:210

Integer the size of this block in bytes

---

### BlockStateRoot

Ƭ **BlockStateRoot**: _string_

Defined in index.d.ts:179

The root of the final state trie of the block

---

### BlockTimeStamp

Ƭ **BlockTimeStamp**: _string_

Defined in index.d.ts:228

The unix timestamp for when the block was collated

---

### BlockTotalDifficulty

Ƭ **BlockTotalDifficulty**: _[Integer](README.md#integer) | [Null](README.md#null)_

Defined in index.d.ts:198

Integer of the total difficulty of the chain until this block

---

### BlockTransactionsRoot

Ƭ **BlockTransactionsRoot**: _string_

Defined in index.d.ts:173

The root of the transactions trie of the block.

---

### BloomFilter

Ƭ **BloomFilter**: _string_

Defined in index.d.ts:362

A 2048 bit bloom filter from the logs of the transaction. Each log sets 3 bits though taking the low-order 11 bits of each of the first three pairs of bytes in a Keccak 256 hash of the log's byte series

---

### BooleanVyG3AETh

Ƭ **BooleanVyG3AETh**: _boolean_

Defined in index.d.ts:537

---

### Bytes

Ƭ **Bytes**: _string_

Defined in index.d.ts:576

Hex representation of a variable length byte array

---

### ChainId

Ƭ **ChainId**: _string_

Defined in index.d.ts:598

---

### ClientVersion

Ƭ **ClientVersion**: _string_

Defined in index.d.ts:589

---

### Data

Ƭ **Data**: _string_

Defined in index.d.ts:538

---

### DataWord

Ƭ **DataWord**: _string_

Defined in index.d.ts:582

Hex representation of a 256 bit unit of data

---

### Difficulty

Ƭ **Difficulty**: _string_

Defined in index.d.ts:493

The boundary condition ('target'), 2^256 / difficulty.

---

### EthBlockNumber

Ƭ **EthBlockNumber**: _function_

Defined in index.d.ts:631

#### Type declaration:

▸ (): _Promise‹[BlockNumberOrTag](README.md#blocknumberortag)›_

---

### EthCall

Ƭ **EthCall**: _function_

Defined in index.d.ts:632

#### Type declaration:

▸ (`transaction`: [Transaction](interfaces/transaction.md), `blockNumber`: [BlockNumberOrTag](README.md#blocknumberortag)): _Promise‹[Bytes](README.md#bytes)›_

**Parameters:**

| Name          | Type                                           |
| ------------- | ---------------------------------------------- |
| `transaction` | [Transaction](interfaces/transaction.md)       |
| `blockNumber` | [BlockNumberOrTag](README.md#blocknumberortag) |

---

### EthChainId

Ƭ **EthChainId**: _function_

Defined in index.d.ts:633

#### Type declaration:

▸ (): _Promise‹[ChainId](README.md#chainid)›_

---

### EthCoinbase

Ƭ **EthCoinbase**: _function_

Defined in index.d.ts:634

#### Type declaration:

▸ (): _Promise‹[Address](README.md#address)›_

---

### EthEstimateGas

Ƭ **EthEstimateGas**: _function_

Defined in index.d.ts:635

#### Type declaration:

▸ (`transaction`: [Transaction](interfaces/transaction.md)): _Promise‹[Integer](README.md#integer)›_

**Parameters:**

| Name          | Type                                     |
| ------------- | ---------------------------------------- |
| `transaction` | [Transaction](interfaces/transaction.md) |

---

### EthGasPrice

Ƭ **EthGasPrice**: _function_

Defined in index.d.ts:636

#### Type declaration:

▸ (): _Promise‹[GasPriceResult](README.md#gaspriceresult)›_

---

### EthGetBalance

Ƭ **EthGetBalance**: _function_

Defined in index.d.ts:637

#### Type declaration:

▸ (`address`: [Address](README.md#address), `blockNumber`: [BlockNumber](README.md#blocknumber)): _Promise‹[IntegerOrNull](README.md#integerornull)›_

**Parameters:**

| Name          | Type                                 |
| ------------- | ------------------------------------ |
| `address`     | [Address](README.md#address)         |
| `blockNumber` | [BlockNumber](README.md#blocknumber) |

---

### EthGetBlockByHash

Ƭ **EthGetBlockByHash**: _function_

Defined in index.d.ts:638

#### Type declaration:

▸ (`blockHash`: [BlockHash](README.md#blockhash), `includeTransactions`: [IsTransactionsIncluded](README.md#istransactionsincluded)): _Promise‹[BlockOrNull](README.md#blockornull)›_

**Parameters:**

| Name                  | Type                                                       |
| --------------------- | ---------------------------------------------------------- |
| `blockHash`           | [BlockHash](README.md#blockhash)                           |
| `includeTransactions` | [IsTransactionsIncluded](README.md#istransactionsincluded) |

---

### EthGetBlockByNumber

Ƭ **EthGetBlockByNumber**: _function_

Defined in index.d.ts:639

#### Type declaration:

▸ (`blockNumber`: [BlockNumberOrTag](README.md#blocknumberortag), `includeTransactions`: [IsTransactionsIncluded](README.md#istransactionsincluded)): _Promise‹[BlockOrNull](README.md#blockornull)›_

**Parameters:**

| Name                  | Type                                                       |
| --------------------- | ---------------------------------------------------------- |
| `blockNumber`         | [BlockNumberOrTag](README.md#blocknumberortag)             |
| `includeTransactions` | [IsTransactionsIncluded](README.md#istransactionsincluded) |

---

### EthGetBlockTransactionCountByHash

Ƭ **EthGetBlockTransactionCountByHash**: _function_

Defined in index.d.ts:640

#### Type declaration:

▸ (`blockHash`: [BlockHash](README.md#blockhash)): _Promise‹[IntegerOrNull](README.md#integerornull)›_

**Parameters:**

| Name        | Type                             |
| ----------- | -------------------------------- |
| `blockHash` | [BlockHash](README.md#blockhash) |

---

### EthGetBlockTransactionCountByNumber

Ƭ **EthGetBlockTransactionCountByNumber**: _function_

Defined in index.d.ts:641

#### Type declaration:

▸ (`blockNumber`: [BlockNumberOrTag](README.md#blocknumberortag)): _Promise‹[IntegerOrNull](README.md#integerornull)›_

**Parameters:**

| Name          | Type                                           |
| ------------- | ---------------------------------------------- |
| `blockNumber` | [BlockNumberOrTag](README.md#blocknumberortag) |

---

### EthGetCode

Ƭ **EthGetCode**: _function_

Defined in index.d.ts:642

#### Type declaration:

▸ (`address`: [Address](README.md#address), `blockNumber`: [BlockNumber](README.md#blocknumber)): _Promise‹[Bytes](README.md#bytes)›_

**Parameters:**

| Name          | Type                                 |
| ------------- | ------------------------------------ |
| `address`     | [Address](README.md#address)         |
| `blockNumber` | [BlockNumber](README.md#blocknumber) |

---

### EthGetFilterChanges

Ƭ **EthGetFilterChanges**: _function_

Defined in index.d.ts:643

#### Type declaration:

▸ (`filterId`: [FilterId](README.md#filterid)): _Promise‹[LogResult](README.md#logresult)›_

**Parameters:**

| Name       | Type                           |
| ---------- | ------------------------------ |
| `filterId` | [FilterId](README.md#filterid) |

---

### EthGetFilterLogs

Ƭ **EthGetFilterLogs**: _function_

Defined in index.d.ts:644

#### Type declaration:

▸ (`filterId`: [FilterId](README.md#filterid)): _Promise‹[SetOfLogs](README.md#setoflogs)›_

**Parameters:**

| Name       | Type                           |
| ---------- | ------------------------------ |
| `filterId` | [FilterId](README.md#filterid) |

---

### EthGetLogs

Ƭ **EthGetLogs**: _function_

Defined in index.d.ts:648

#### Type declaration:

▸ (`filter`: [Filter](interfaces/filter.md)): _Promise‹[SetOfLogs](README.md#setoflogs)›_

**Parameters:**

| Name     | Type                           |
| -------- | ------------------------------ |
| `filter` | [Filter](interfaces/filter.md) |

---

### EthGetProof

Ƭ **EthGetProof**: _function_

Defined in index.d.ts:659

#### Type declaration:

▸ (`address`: [Address](README.md#address), `storageKeys`: [StorageKeys](README.md#storagekeys), `blockNumber`: [BlockNumberOrTag](README.md#blocknumberortag)): _Promise‹[ProofAccountOrNull](README.md#proofaccountornull)›_

**Parameters:**

| Name          | Type                                           |
| ------------- | ---------------------------------------------- |
| `address`     | [Address](README.md#address)                   |
| `storageKeys` | [StorageKeys](README.md#storagekeys)           |
| `blockNumber` | [BlockNumberOrTag](README.md#blocknumberortag) |

---

### EthGetRawTransactionByBlockHashAndIndex

Ƭ **EthGetRawTransactionByBlockHashAndIndex**: _function_

Defined in index.d.ts:646

#### Type declaration:

▸ (`blockHash`: [BlockHash](README.md#blockhash), `index`: [Integer](README.md#integer)): _Promise‹[Bytes](README.md#bytes)›_

**Parameters:**

| Name        | Type                             |
| ----------- | -------------------------------- |
| `blockHash` | [BlockHash](README.md#blockhash) |
| `index`     | [Integer](README.md#integer)     |

---

### EthGetRawTransactionByBlockNumberAndIndex

Ƭ **EthGetRawTransactionByBlockNumberAndIndex**: _function_

Defined in index.d.ts:647

#### Type declaration:

▸ (`blockNumber`: [BlockNumberOrTag](README.md#blocknumberortag), `index`: [Integer](README.md#integer)): _Promise‹[Bytes](README.md#bytes)›_

**Parameters:**

| Name          | Type                                           |
| ------------- | ---------------------------------------------- |
| `blockNumber` | [BlockNumberOrTag](README.md#blocknumberortag) |
| `index`       | [Integer](README.md#integer)                   |

---

### EthGetRawTransactionByHash

Ƭ **EthGetRawTransactionByHash**: _function_

Defined in index.d.ts:645

#### Type declaration:

▸ (`transactionHash`: [TransactionHash](README.md#transactionhash)): _Promise‹[Bytes](README.md#bytes)›_

**Parameters:**

| Name              | Type                                         |
| ----------------- | -------------------------------------------- |
| `transactionHash` | [TransactionHash](README.md#transactionhash) |

---

### EthGetStorageAt

Ƭ **EthGetStorageAt**: _function_

Defined in index.d.ts:649

#### Type declaration:

▸ (`address`: [Address](README.md#address), `key`: [Position](README.md#position), `blockNumber`: [BlockNumberOrTag](README.md#blocknumberortag)): _Promise‹[DataWord](README.md#dataword)›_

**Parameters:**

| Name          | Type                                           |
| ------------- | ---------------------------------------------- |
| `address`     | [Address](README.md#address)                   |
| `key`         | [Position](README.md#position)                 |
| `blockNumber` | [BlockNumberOrTag](README.md#blocknumberortag) |

---

### EthGetTransactionByBlockHashAndIndex

Ƭ **EthGetTransactionByBlockHashAndIndex**: _function_

Defined in index.d.ts:650

#### Type declaration:

▸ (`blockHash`: [BlockHash](README.md#blockhash), `index`: [Integer](README.md#integer)): _Promise‹[TransactionOrNull](README.md#transactionornull)›_

**Parameters:**

| Name        | Type                             |
| ----------- | -------------------------------- |
| `blockHash` | [BlockHash](README.md#blockhash) |
| `index`     | [Integer](README.md#integer)     |

---

### EthGetTransactionByBlockNumberAndIndex

Ƭ **EthGetTransactionByBlockNumberAndIndex**: _function_

Defined in index.d.ts:651

#### Type declaration:

▸ (`blockNumber`: [BlockNumberOrTag](README.md#blocknumberortag), `index`: [Integer](README.md#integer)): _Promise‹[TransactionOrNull](README.md#transactionornull)›_

**Parameters:**

| Name          | Type                                           |
| ------------- | ---------------------------------------------- |
| `blockNumber` | [BlockNumberOrTag](README.md#blocknumberortag) |
| `index`       | [Integer](README.md#integer)                   |

---

### EthGetTransactionByHash

Ƭ **EthGetTransactionByHash**: _function_

Defined in index.d.ts:652

#### Type declaration:

▸ (`transactionHash`: [TransactionHash](README.md#transactionhash)): _Promise‹[TransactionOrNull](README.md#transactionornull)›_

**Parameters:**

| Name              | Type                                         |
| ----------------- | -------------------------------------------- |
| `transactionHash` | [TransactionHash](README.md#transactionhash) |

---

### EthGetTransactionCount

Ƭ **EthGetTransactionCount**: _function_

Defined in index.d.ts:653

#### Type declaration:

▸ (`address`: [Address](README.md#address), `blockNumber`: [BlockNumberOrTag](README.md#blocknumberortag)): _Promise‹[NonceOrNull](README.md#nonceornull)›_

**Parameters:**

| Name          | Type                                           |
| ------------- | ---------------------------------------------- |
| `address`     | [Address](README.md#address)                   |
| `blockNumber` | [BlockNumberOrTag](README.md#blocknumberortag) |

---

### EthGetTransactionReceipt

Ƭ **EthGetTransactionReceipt**: _function_

Defined in index.d.ts:654

#### Type declaration:

▸ (`transactionHash`: [TransactionHash](README.md#transactionhash)): _Promise‹[TransactionReceiptOrNull](README.md#transactionreceiptornull)›_

**Parameters:**

| Name              | Type                                         |
| ----------------- | -------------------------------------------- |
| `transactionHash` | [TransactionHash](README.md#transactionhash) |

---

### EthGetUncleByBlockHashAndIndex

Ƭ **EthGetUncleByBlockHashAndIndex**: _function_

Defined in index.d.ts:655

#### Type declaration:

▸ (`blockHash`: [BlockHash](README.md#blockhash), `index`: [Integer](README.md#integer)): _Promise‹[BlockOrNull](README.md#blockornull)›_

**Parameters:**

| Name        | Type                             |
| ----------- | -------------------------------- |
| `blockHash` | [BlockHash](README.md#blockhash) |
| `index`     | [Integer](README.md#integer)     |

---

### EthGetUncleByBlockNumberAndIndex

Ƭ **EthGetUncleByBlockNumberAndIndex**: _function_

Defined in index.d.ts:656

#### Type declaration:

▸ (`uncleBlockNumber`: [BlockNumber](README.md#blocknumber), `index`: [Integer](README.md#integer)): _Promise‹[BlockOrNull](README.md#blockornull)›_

**Parameters:**

| Name               | Type                                 |
| ------------------ | ------------------------------------ |
| `uncleBlockNumber` | [BlockNumber](README.md#blocknumber) |
| `index`            | [Integer](README.md#integer)         |

---

### EthGetUncleCountByBlockHash

Ƭ **EthGetUncleCountByBlockHash**: _function_

Defined in index.d.ts:657

#### Type declaration:

▸ (`blockHash`: [BlockHash](README.md#blockhash)): _Promise‹[IntegerOrNull](README.md#integerornull)›_

**Parameters:**

| Name        | Type                             |
| ----------- | -------------------------------- |
| `blockHash` | [BlockHash](README.md#blockhash) |

---

### EthGetUncleCountByBlockNumber

Ƭ **EthGetUncleCountByBlockNumber**: _function_

Defined in index.d.ts:658

#### Type declaration:

▸ (`blockNumber`: [BlockNumberOrTag](README.md#blocknumberortag)): _Promise‹[IntegerOrNull](README.md#integerornull)›_

**Parameters:**

| Name          | Type                                           |
| ------------- | ---------------------------------------------- |
| `blockNumber` | [BlockNumberOrTag](README.md#blocknumberortag) |

---

### EthGetWork

Ƭ **EthGetWork**: _function_

Defined in index.d.ts:660

#### Type declaration:

▸ (): _Promise‹[GetWorkResults](README.md#getworkresults)›_

---

### EthHashrate

Ƭ **EthHashrate**: _function_

Defined in index.d.ts:661

#### Type declaration:

▸ (): _Promise‹[Integer](README.md#integer)›_

---

### EthMining

Ƭ **EthMining**: _function_

Defined in index.d.ts:662

#### Type declaration:

▸ (): _Promise‹[BooleanVyG3AETh](README.md#booleanvyg3aeth)›_

---

### EthNewBlockFilter

Ƭ **EthNewBlockFilter**: _function_

Defined in index.d.ts:663

#### Type declaration:

▸ (): _Promise‹[FilterId](README.md#filterid)›_

---

### EthNewFilter

Ƭ **EthNewFilter**: _function_

Defined in index.d.ts:664

#### Type declaration:

▸ (`filter`: [Filter](interfaces/filter.md)): _Promise‹[Integer](README.md#integer)›_

**Parameters:**

| Name     | Type                           |
| -------- | ------------------------------ |
| `filter` | [Filter](interfaces/filter.md) |

---

### EthNewPendingTransactionFilter

Ƭ **EthNewPendingTransactionFilter**: _function_

Defined in index.d.ts:665

#### Type declaration:

▸ (): _Promise‹[FilterId](README.md#filterid)›_

---

### EthPendingTransactions

Ƭ **EthPendingTransactions**: _function_

Defined in index.d.ts:666

#### Type declaration:

▸ (): _Promise‹[Transactions](README.md#transactions)›_

---

### EthProtocolVersion

Ƭ **EthProtocolVersion**: _function_

Defined in index.d.ts:667

#### Type declaration:

▸ (): _Promise‹[Integer](README.md#integer)›_

---

### EthSendRawTransaction

Ƭ **EthSendRawTransaction**: _function_

Defined in index.d.ts:668

#### Type declaration:

▸ (`signedTransactionData`: [Bytes](README.md#bytes)): _Promise‹[Keccak](README.md#keccak)›_

**Parameters:**

| Name                    | Type                     |
| ----------------------- | ------------------------ |
| `signedTransactionData` | [Bytes](README.md#bytes) |

---

### EthSubmitHashrate

Ƭ **EthSubmitHashrate**: _function_

Defined in index.d.ts:669

#### Type declaration:

▸ (`hashRate`: [DataWord](README.md#dataword), `id`: [DataWord](README.md#dataword)): _Promise‹[BooleanVyG3AETh](README.md#booleanvyg3aeth)›_

**Parameters:**

| Name       | Type                           |
| ---------- | ------------------------------ |
| `hashRate` | [DataWord](README.md#dataword) |
| `id`       | [DataWord](README.md#dataword) |

---

### EthSubmitWork

Ƭ **EthSubmitWork**: _function_

Defined in index.d.ts:670

#### Type declaration:

▸ (`nonce`: [Nonce](README.md#nonce), `powHash`: [PowHash](README.md#powhash), `mixHash`: [MixHash](README.md#mixhash)): _Promise‹[BooleanVyG3AETh](README.md#booleanvyg3aeth)›_

**Parameters:**

| Name      | Type                         |
| --------- | ---------------------------- |
| `nonce`   | [Nonce](README.md#nonce)     |
| `powHash` | [PowHash](README.md#powhash) |
| `mixHash` | [MixHash](README.md#mixhash) |

---

### EthSyncing

Ƭ **EthSyncing**: _function_

Defined in index.d.ts:671

#### Type declaration:

▸ (): _Promise‹[IsSyncingResult](README.md#issyncingresult)›_

---

### EthUninstallFilter

Ƭ **EthUninstallFilter**: _function_

Defined in index.d.ts:672

#### Type declaration:

▸ (`filterId`: [FilterId](README.md#filterid)): _Promise‹[BooleanVyG3AETh](README.md#booleanvyg3aeth)›_

**Parameters:**

| Name       | Type                           |
| ---------- | ------------------------------ |
| `filterId` | [FilterId](README.md#filterid) |

---

### FilterId

Ƭ **FilterId**: _string_

Defined in index.d.ts:546

An identifier used to reference the filter.

---

### From

Ƭ **From**: _string_

Defined in index.d.ts:38

The sender of the transaction

---

### GasPriceResult

Ƭ **GasPriceResult**: _string_

Defined in index.d.ts:604

Integer of the current gas price

---

### GetWorkResults

Ƭ **GetWorkResults**: _[[PowHash](README.md#powhash), [SeedHash](README.md#seedhash), [Difficulty](README.md#difficulty)]_

Defined in index.d.ts:612

---

### Integer

Ƭ **Integer**: _string_

Defined in index.d.ts:81

Hex representation of the integer

---

### IntegerOrNull

Ƭ **IntegerOrNull**: _[Integer](README.md#integer) | [Null](README.md#null)_

Defined in index.d.ts:605

---

### IsNetListening

Ƭ **IsNetListening**: _boolean_

Defined in index.d.ts:590

---

### IsSyncingResult

Ƭ **IsSyncingResult**: _[SyncingData](interfaces/syncingdata.md) | [BooleanVyG3AETh](README.md#booleanvyg3aeth)_

Defined in index.d.ts:619

---

### IsTransactionsIncluded

Ƭ **IsTransactionsIncluded**: _boolean_

Defined in index.d.ts:540

---

### Keccak

Ƭ **Keccak**: _string_

Defined in index.d.ts:8

Hex representation of a Keccak 256 hash

---

### LogAddress

Ƭ **LogAddress**: _string_

Defined in index.d.ts:297

Sender of the transaction

---

### LogData

Ƭ **LogData**: _string_

Defined in index.d.ts:303

The data/input string sent along with the transaction

---

### LogIndex

Ƭ **LogIndex**: _string_

Defined in index.d.ts:309

The index of the event within its transaction, null when its pending

---

### LogIsRemoved

Ƭ **LogIsRemoved**: _boolean_

Defined in index.d.ts:315

Whether or not the log was orphaned off the main chain

---

### LogResult

Ƭ **LogResult**: _[Log](interfaces/log.md)[]_

Defined in index.d.ts:607

---

### LogTopics

Ƭ **LogTopics**: _[Topic](README.md#topic)[]_

Defined in index.d.ts:136

Topics are order-dependent. Each topic can also be an array of DATA with 'or' options.

---

### Logs

Ƭ **Logs**: _[Log](interfaces/log.md)[]_

Defined in index.d.ts:356

An array of all the logs triggered during the transaction

---

### MixHash

Ƭ **MixHash**: _string_

Defined in index.d.ts:588

The mix digest.

---

### NetListening

Ƭ **NetListening**: _function_

Defined in index.d.ts:628

#### Type declaration:

▸ (): _Promise‹[IsNetListening](README.md#isnetlistening)›_

---

### NetPeerCount

Ƭ **NetPeerCount**: _function_

Defined in index.d.ts:629

#### Type declaration:

▸ (): _Promise‹[NumConnectedPeers](README.md#numconnectedpeers)›_

---

### NetVersion

Ƭ **NetVersion**: _function_

Defined in index.d.ts:630

#### Type declaration:

▸ (): _Promise‹[NetworkId](README.md#networkid)›_

---

### NetworkId

Ƭ **NetworkId**: _string_

Defined in index.d.ts:597

---

### Nonce

Ƭ **Nonce**: _string_

Defined in index.d.ts:154

A number only to be used once

---

### NonceOrNull

Ƭ **NonceOrNull**: _[Nonce](README.md#nonce) | [Null](README.md#null)_

Defined in index.d.ts:155

---

### Null

Ƭ **Null**: _null_

Defined in index.d.ts:14

Null

---

### NumConnectedPeers

Ƭ **NumConnectedPeers**: _string_

Defined in index.d.ts:596

Hex representation of number of connected peers

---

### OneOrArrayOfAddresses

Ƭ **OneOrArrayOfAddresses**: _[Address](README.md#address) | [Addresses](README.md#addresses)_

Defined in index.d.ts:124

---

### Position

Ƭ **Position**: _string_

Defined in index.d.ts:564

Hex representation of the storage slot where the variable exists

---

### PowHash

Ƭ **PowHash**: _string_

Defined in index.d.ts:481

Current block header PoW hash.

---

### ProofAccountAddress

Ƭ **ProofAccountAddress**: _string_

Defined in index.d.ts:401

The address of the account or contract of the request

---

### ProofAccountBalance

Ƭ **ProofAccountBalance**: _string_

Defined in index.d.ts:419

The Ether balance of the account or contract of the request

---

### ProofAccountCodeHash

Ƭ **ProofAccountCodeHash**: _string_

Defined in index.d.ts:425

The code hash of the contract of the request (keccak(NULL) if external account)

---

### ProofAccountNonce

Ƭ **ProofAccountNonce**: _string_

Defined in index.d.ts:431

The transaction count of the account or contract of the request

---

### ProofAccountOrNull

Ƭ **ProofAccountOrNull**: _[ProofAccount](interfaces/proofaccount.md) | [Null](README.md#null)_

Defined in index.d.ts:611

---

### ProofAccountStorageHash

Ƭ **ProofAccountStorageHash**: _string_

Defined in index.d.ts:437

The storage hash of the contract of the request (keccak(rlp(NULL)) if external account)

---

### ProofNode

Ƭ **ProofNode**: _string_

Defined in index.d.ts:407

An individual node used to prove a path down a merkle-patricia-tree

---

### ProofNodes

Ƭ **ProofNodes**: _[ProofNode](README.md#proofnode)[]_

Defined in index.d.ts:413

The set of node values needed to traverse a patricia merkle tree (from root to leaf) to retrieve a value

---

### ReceiptContractAddress

Ƭ **ReceiptContractAddress**: _[Address](README.md#address) | [Null](README.md#null)_

Defined in index.d.ts:338

The contract address created, if the transaction was a contract creation, otherwise null

---

### ReceiptCumulativeGasUsed

Ƭ **ReceiptCumulativeGasUsed**: _string_

Defined in index.d.ts:344

The gas units used by the transaction

---

### ReceiptGasUsed

Ƭ **ReceiptGasUsed**: _string_

Defined in index.d.ts:350

The total gas used by the transaction

---

### ReceiptPostTransactionState

Ƭ **ReceiptPostTransactionState**: _string_

Defined in index.d.ts:368

The intermediate stateRoot directly after transaction execution.

---

### ReceiptStatus

Ƭ **ReceiptStatus**: _boolean_

Defined in index.d.ts:374

Whether or not the transaction threw an error.

---

### SeedHash

Ƭ **SeedHash**: _string_

Defined in index.d.ts:487

The seed hash used for the DAG.

---

### SetOfLogs

Ƭ **SetOfLogs**: _[Log](interfaces/log.md)[]_

Defined in index.d.ts:608

---

### StorageKeys

Ƭ **StorageKeys**: _any_

Defined in index.d.ts:570

A storage key is indexed from the solidity compiler by the order it is declared. For mappings it uses the keccak of the mapping key with its position (and recursively for X-dimensional mappings)

---

### StorageProofKey

Ƭ **StorageProofKey**: _string_

Defined in index.d.ts:142

The key used to get the storage slot in its account tree.

---

### StorageProofSet

Ƭ **StorageProofSet**: _[StorageProof](interfaces/storageproof.md)[]_

Defined in index.d.ts:460

Current block header PoW hash.

---

### StorageProofValue

Ƭ **StorageProofValue**: _string_

Defined in index.d.ts:443

The value of the storage slot in its account tree

---

### SyncingDataCurrentBlock

Ƭ **SyncingDataCurrentBlock**: _string_

Defined in index.d.ts:505

The current block, same as eth_blockNumber

---

### SyncingDataHighestBlock

Ƭ **SyncingDataHighestBlock**: _string_

Defined in index.d.ts:511

The estimated highest block

---

### SyncingDataKnownStates

Ƭ **SyncingDataKnownStates**: _string_

Defined in index.d.ts:517

The known states

---

### SyncingDataPulledStates

Ƭ **SyncingDataPulledStates**: _string_

Defined in index.d.ts:523

The pulled states

---

### SyncingDataStartingBlock

Ƭ **SyncingDataStartingBlock**: _string_

Defined in index.d.ts:499

Block at which the import started (will only be reset, after the sync reached his head)

---

### To

Ƭ **To**: _[Address](README.md#address) | [Null](README.md#null)_

Defined in index.d.ts:75

Destination address of the transaction. Null if it was a contract create.

---

### Topic

Ƭ **Topic**: _string_

Defined in index.d.ts:130

32 Bytes DATA of indexed log arguments. (In solidity: The first topic is the hash of the signature of the event (e.g. Deposit(address,bytes32,uint256))

---

### TransactionGas

Ƭ **TransactionGas**: _string_

Defined in index.d.ts:44

The gas limit provided by the sender in Wei

---

### TransactionGasPrice

Ƭ **TransactionGasPrice**: _string_

Defined in index.d.ts:50

The gas price willing to be paid by the sender in Wei

---

### TransactionHash

Ƭ **TransactionHash**: _string_

Defined in index.d.ts:56

Keccak 256 Hash of the RLP encoding of a transaction

---

### TransactionIndex

Ƭ **TransactionIndex**: _[Integer](README.md#integer) | [Null](README.md#null)_

Defined in index.d.ts:87

The index of the transaction. null when its pending

---

### TransactionInput

Ƭ **TransactionInput**: _string_

Defined in index.d.ts:62

The data field sent with the transaction

---

### TransactionNonce

Ƭ **TransactionNonce**: _string_

Defined in index.d.ts:68

The total number of prior transactions made by the sender

---

### TransactionOrNull

Ƭ **TransactionOrNull**: _[Transaction](interfaces/transaction.md) | [Null](README.md#null)_

Defined in index.d.ts:609

---

### TransactionOrTransactionHash

Ƭ **TransactionOrTransactionHash**: _[Transaction](interfaces/transaction.md) | [TransactionHash](README.md#transactionhash)_

Defined in index.d.ts:246

---

### TransactionReceiptOrNull

Ƭ **TransactionReceiptOrNull**: _[Receipt](interfaces/receipt.md) | [Null](README.md#null)_

Defined in index.d.ts:610

---

### TransactionSigR

Ƭ **TransactionSigR**: _string_

Defined in index.d.ts:105

ECDSA signature r

---

### TransactionSigS

Ƭ **TransactionSigS**: _string_

Defined in index.d.ts:111

ECDSA signature s

---

### TransactionSigV

Ƭ **TransactionSigV**: _string_

Defined in index.d.ts:99

ECDSA recovery id

---

### TransactionValue

Ƭ **TransactionValue**: _string_

Defined in index.d.ts:93

Value of Ether being transferred in Wei

---

### Transactions

Ƭ **Transactions**: _[Transaction](interfaces/transaction.md)[]_

Defined in index.d.ts:618

An array of transactions

---

### TransactionsOrHashes

Ƭ **TransactionsOrHashes**: _[TransactionOrTransactionHash](README.md#transactionortransactionhash)[]_

Defined in index.d.ts:252

Array of transaction objects, or 32 Bytes transaction hashes depending on the last given parameter

---

### UncleHash

Ƭ **UncleHash**: _string_

Defined in index.d.ts:258

Block hash of the RLP encoding of an uncle block

---

### UncleHashes

Ƭ **UncleHashes**: _[UncleHash](README.md#unclehash)[]_

Defined in index.d.ts:264

Array of uncle hashes

---

### Web3ClientVersion

Ƭ **Web3ClientVersion**: _function_

Defined in index.d.ts:626

#### Type declaration:

▸ (): _Promise‹[ClientVersion](README.md#clientversion)›_

---

### Web3Sha3

Ƭ **Web3Sha3**: _function_

Defined in index.d.ts:627

#### Type declaration:

▸ (`data`: [Data](README.md#data)): _Promise‹[Keccak](README.md#keccak)›_

**Parameters:**

| Name   | Type                   |
| ------ | ---------------------- |
| `data` | [Data](README.md#data) |
